1 # Common helper routines for test shell scripts -- intended to be sourced by them
5 #### The following exported variables are set by "make check". Ensure
6 #### that they are set here so that individual tests can be run
7 #### outside of make. Requires that MH_OBJ_DIR be set on entry.
8 test -z "$MH_TEST_DIR" && MH_TEST_DIR
="$MH_OBJ_DIR/test/testdir"
9 test -z "$prefix" && prefix
=@prefix@
10 test -z "$datarootdir" && datarootdir
=@datarootdir@
11 test -z "$exec_prefix" && exec_prefix
=@exec_prefix@
12 test -z "$auxexecdir" && auxexecdir
="@libdir@"
13 test -z "$bindir" && bindir
="@bindir@"
14 test -z "$mandir" && mandir
="@mandir@"
15 test -z "$sysconfdir" && sysconfdir
="@sysconfdir@"
16 test -z "$supported_locks" && supported_locks
="@supported_locks@"
17 test -z "$MULTIBYTE_ENABLED" && MULTIBYTE_ENABLED
="@MULTIBYTE_ENABLED@"
18 test -z "$ICONV_ENABLED" && ICONV_ENABLED
="@ICONV_ENABLED@"
19 export MH_TEST_DIR auxexecdir bindir mandir sysconfdir
20 export MULTIBYTE_ENABLED ICONV_ENABLED
22 test -z "$MH_INST_DIR" && MH_INST_DIR
="${MH_TEST_DIR}/inst"
25 unset MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE
26 unset MHLDEBUG MHPDEBUG MHWDEBUG MM_CHARSET PAGER
28 #### Use a test dir for tmp files when MHTMPDIR applies.
29 MHTMPDIR
=$MH_TEST_DIR/Mail
34 #### Output just the checksum. If the filename needs to appear on
35 #### the same line, the caller needs to add it. This avoids
36 #### differences due to a leading '*' binary file indicator, for
37 #### text files, on some platforms (Cygwin).
38 @MD5SUM@ $
* | @MD5FMT@
| cut
-d ' ' -f 1
41 #### Use built-in $((...)) in test suite if shell supports it.
42 #### Borrowed from configure's as_fn_arith. The result is placed
43 #### in global arith_val.
44 #### Detected at run-time instead of by configure to allow testing
45 #### with different shells.
46 if (eval "test \$(( 1 + 1 )) = 2" 2>/dev
/null
); then
47 eval 'arith_eval () { arith_val=$(( $* )); }'
49 arith_eval
() { arith_val
=`expr "$@" || test $? -eq 1`; }
55 echo "$Test $0 SKIP ($WHY)"
59 # portable implementation of 'which' utility
63 #### Don't need to save current IFS because this function is run in
70 if [ -f "$D/$PROG" -a -x "$D/$PROG" ]; then
71 printf '%s\n' "$D/$PROG"
79 if [ -z "`findprog $1`" ]; then
80 test_skip
"missing $1"
84 # Some stuff for doing silly progress indicators
91 arith_eval
$LAST - $FIRST; RANGE
=$arith_val
92 arith_eval
$THIS - $FIRST; PROG
=$arith_val
93 # this automatically rounds to nearest integer
94 arith_eval
100 \
* $PROG / $RANGE; PERC
=$arith_val
95 # note \r so next update will overwrite
96 printf '%3d%%\r' $PERC
104 # don't emit anything if stdout is not connected to a tty.
115 check_for_hard_links
() {
118 printf '' > "${MH_TEST_DIR}/$$-1"
119 if link
"${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2" 2>/dev
/null
; then
120 hard_links_supported
=1
122 hard_links_supported
=0
124 rm -f "${MH_TEST_DIR}/$$-1" "${MH_TEST_DIR}/$$-2"
129 #### check() requires two arguments, each the name of a file to be
131 #### If the same, the second file is removed. And the first file is
132 #### removed unless there's an optional argument with a value of
134 #### If different, global variable "failed" is incremented.
135 #### If there's an optional 'ignore space' argument, diff -b will
136 #### be used instead of cmp to compare the files.
142 while [ $# -gt 0 ]; do
144 'keep first') keepfirst
=1 ;;
145 'ignore space') ignorespace
=1 ;;
146 *) echo "$0: invalid check() argument \"$1\" in test suite" >&2 ;;
152 if [ "$ignorespace" ]; then
153 #### POSIX diff should support -b.
154 diff -b "$first" "$second" >/dev
/null
&& success
=1
156 cmp -s "$first" "$second" && success
=1
159 if [ "$success" ]; then
160 [ "$keepfirst" ] || rm -f "$first"
164 #### POSIX diff should support -c.
165 diff -c "$first" "$second" || true
167 echo "$0: test failed, outputs are in $first and $second."
168 failed
=`expr ${failed:-0} + 1`
169 #### Set return status of the function.
174 #### run_test() requires two arguments, the first is a program and
175 #### arguments, the second is its expected one-line output string.
176 #### If the actual output does not match that string:
177 #### an error message is printed and global variable "failed" is incremented;
178 #### if there is an optional third argument, it is used in the error message.
181 actual_output
=`$1 2>&1`
183 if test x
"$actual_output" != x
"$2"; then
184 echo "$0: ${3:-\"$1\"} expected:" 1>&2
186 echo "but instead got:" 1>&2
187 echo " '$actual_output'" 1>&2
188 failed
=`expr ${failed:-0} + 1`
194 MH
="${MH_TEST_DIR}/Mail/.mh_profile"
195 MHMTSCONF
="${MH_INST_DIR}${sysconfdir}/mts.conf"
196 MH_LIB_DIR
="${MH_INST_DIR}${auxexecdir}"
197 export MH MHMTSCONF MH_LIB_DIR
202 if [ -d "${MH_INST_DIR}${bindir}" ]; then
205 (cd "${MH_OBJ_DIR}" &&
206 make DESTDIR
="${MH_INST_DIR}" SETGID_MAIL
= install) ||
209 #### Don't test with sendmail because it would really send the
210 #### mail. If configured to use sendmail, change to smtp instead
211 #### so that we use fakesmtp.
212 #### And set up the maildrop in the test directory so tests don't
213 #### use the user's real maildrop.
214 #### test-slocal needs to look at the original mts.conf, so save it.
215 mv -f "${MHMTSCONF}" "${MHMTSCONF}.old"
216 sed -e 's/mts: *.*/mts: smtp/' \
217 -e "s%mmdfldir: *.*%mmdfldir: ${MH_TEST_DIR}/Mail%" \
218 -e 's%mmdflfil: *.*%mmdflfil: maildrop%' \
219 "${MHMTSCONF}.old" >"${MHMTSCONF}"
222 #### On Solaris, must set PATH after the install!
223 PATH
="${MH_INST_DIR}${bindir}:${PATH}"
226 # clean old test data
227 trap "rm -rf '$MH_TEST_DIR/Mail'" 0
229 mkdir -p "$MH_TEST_DIR/Mail" || exit 1
230 cat > "$MH" <<EOF || exit 1
231 Path: ${MH_TEST_DIR}/Mail
232 buildmimeproc: ${MH_INST_DIR}${bindir}/mhbuild
233 fileproc: ${MH_INST_DIR}${bindir}/refile
234 libdir: ${MH_LIB_DIR}
235 mhbuild: -nocontentid
236 mhlproc: ${MH_LIB_DIR}/mhl
238 postproc: ${MH_LIB_DIR}/post
239 showproc: ${MH_LIB_DIR}/mhl
242 for f
in MailAliases components digestcomps distcomps forwcomps mhl.body \
243 mhl.digest mhl.format mhl.forward mhl.headers mhl.reply \
244 mhn.defaults rcvdistcomps replcomps replgroupcomps scan.MMDDYY \
245 scan.YYYYMMDD scan.default scan.highlighted scan.mailx scan.nomime \
246 scan.size scan.
time scan.timely scan.unseen
248 cp "${MH_INST_DIR}${sysconfdir}/${f}" "${MH_TEST_DIR}/Mail" || exit 1
251 folder
-create +inbox
> /dev
/null
252 # create 10 basic messages
253 for i
in 1 2 3 4 5 6 7 8 9 10;
255 cat > $MH_TEST_DIR/Mail
/inbox
/$i <<EOF || exit 1
256 From: Test$i <test$i@example.com>
257 To: Some User <user@example.com>
258 Date: Fri, 29 Sep 2006 00:00:00
259 Message-Id: $i@test.nmh
260 Subject: Testing message $i
262 This is message number $i